//  this applet draws some circles 

import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

public class Concentric extends Applet {
  public void paint(Graphics g) {
    //  draw some concentric circles

    Rectangle size = getBounds();
    int width = size.width;
    int height = size.height;

    showStatus("Dimensions: (" + width + "," + height + ")");

    Color colors[] = { Color.black, Color.white };
    //int diff = 30; // space between circles 
    int c_x = width >> 1;
    int c_y = height >> 1;
    int n = 150; // number of circles
    int i = 0;

    //int s = start;

    double r_x = width;
    double r_y = height;

    for (int j = 0; j != n; j++) {
      g.setColor(colors[i++ & 1]);

      fillOval(g, c_x - r_x, c_y - r_y, r_x * 2, r_y * 2);
      double dx = Math.max(1,  r_x * 0.05);
      double dy = Math.max(1,  r_y * 0.05);
      r_x = r_x - dx;
      r_y = r_y - dy;
    }
  }

  void fillOval(Graphics g, double x, double y, double w, double h) {
    g.fillOval((int) x, (int) y, (int) w, (int) h);
  }
}
