import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.imageio.ImageIO;

import utilities.log.Log;
import utilities.log.LogAdaptorSystemOut;

public class LCDImageProcess {
  public static ImageWrapper process(ImageWrapper in) {
    int width_in = in.getWidth();
    int height_in = in.getHeight();
    int width_out = width_in / 3;
    int height_out = height_in;
    
    in.getSource();

    int[] array = new int[width_out * height_out];

    int i = 0;

    for (int y = 0; y < height_out; y++) {
      for (int x = 0; x < width_out; x++) {
        int x_from = x * 3;
        int pix_m2 = getPixelColour(in, x_from - 2, y);
        int pix_m1 = getPixelColour(in, x_from - 1, y);
        int pix_0 = getPixelColour(in, x_from - 0, y);
        int pix_1 = getPixelColour(in, x_from + 1, y);
        int pix_2 = getPixelColour(in, x_from + 2, y);

        //int pix_m2r = pix_m2 & 0xFF;
        //int pix_m1r = pix_m1 & 0xFF;
        int pix_0r = pix_0 & 0xFF;
        int pix_1r = pix_1 & 0xFF;
        int pix_2r = pix_2 & 0xFF;

        //int pix_m2g = (pix_m2 & 0xFF00) >> 8;
        int pix_m1g = (pix_m1 & 0xFF00) >> 8;
        int pix_0g = (pix_0 & 0xFF00) >> 8;
        int pix_1g = (pix_1 & 0xFF00) >> 8;
        //int pix_2g = (pix_2 & 0xFF00) >> 8;

        int pix_m2b = (pix_m2 & 0xFF0000) >> 16;
        int pix_m1b = (pix_m1 & 0xFF0000) >> 16;
        int pix_0b = (pix_0 & 0xFF0000) >> 16;
        //int pix_1b = (pix_1 & 0xFF0000) >> 16;
       // int pix_2b = (pix_2 & 0xFF0000) >> 16;

//        int r = (pix_m2r * 85 + pix_m1r * 85 + pix_0r * 85) >> 8;
//        int g = (pix_m1g * 85 + pix_0g * 85 + pix_1g * 85) >> 8;
//        int b = (pix_0b * 85 + pix_1b * 85 + pix_2b * 85) >> 8;
      
        int r = (pix_0r * 85 + pix_1r * 85 + pix_2r * 85) >> 8;
         int g = (pix_m1g * 85 + pix_0g * 85 + pix_1g * 85) >> 8;
         int b = (pix_m2b * 85 + pix_m1b * 85 + pix_0b * 85) >> 8;

        int pix_out = 0xFF000000 | b << 16 | g << 8 | r;
        array[i++] = pix_out;
      }
    }

    ImageWrapper out = new ImageWrapper(array, width_out, height_out);
    return out;
  }

  public static int getPixelColour(ImageWrapper i, int x, int y) {
    int width_in = i.getWidth();

    if (x < 0) {
      x += width_in;
    }
    if (x >= width_in) {
      x -= width_in;
    }

    return i.getPixelColour(x, y);
  }
}
